package fllcc

import (
	"fmt"

	"gogs.daxia.dev/huanan/pkg.daxia.dev/fllcc/video_decrypt"
)

//启动
func KStartup(dir string, cacheDir string, cacheSize int) {
	startup(dir, cacheDir, cacheSize)
}

//获取内部播放地址
func KGetPlayUrl(oriPlayUrl string) string {
	return getPlayUrl(oriPlayUrl)
}

//开启日志记录
func KStartLog(enableLog bool) {
	//startLog(enableLog)
}

//启动视频的反向代理，用于解密播放
// @reverseUrl 反向地址路径，eg:https://video-up.oss-accelerate.aliyuncs.com
// @reverseHost 反向地址，需要手动设置host，eg:video-up.oss-accelerate.aliyuncs.com
func KVideoEncStartup(reverseUrl string, reverseHost string) int {
	err := video_decrypt.StartServer(reverseUrl, reverseHost)
	if err != nil {
		fmt.Println(err)
		return -1
	}

	return 0
}

//加密上传视频的内容
func KVideoEncData(data []byte, key string) ([]byte, error) {
	return video_decrypt.EncryptData(data, key)
}

//获取请求地址：
//  反向代理到服务器
//  请求需要带上头enc_key，长度最少14位
func KVideoEncGetHostPath() string {
	return video_decrypt.GetHostPath()
}
